<template lang="pug">
  .text-tools(
    v-show="isShown"
    :class="{ small: isSmall }"
    :style="styles"
  )
    .actions

      .action.first.color-picker(
        v-tooltip:top="'Change color'"
        @click="$emit('color-picker-clicked')"
        ref="colorPickerButton"
      )
        img(src='~static/vue-static/swatch.png')

      .action(
        @click="textBold" :class="{ active: bold }"
        v-tooltip:top="'Bold'"
      )
        .icon(v-html="$icons['text/bold']")

      .action(
        @click="textItalic" :class="{ active: italic }"
        v-tooltip:top="'Italic'"
      )
        .icon(v-html="$icons['text/italic']")

      .action(
        @click="textLeft" :class="{ active: left }"
        v-tooltip:top="'Left'"
      )
        .icon(v-html="$icons['text/left']")

      .action(
        @click="textCenter" :class="{ active: center }"
        v-tooltip:top="'Center'"
      )
        .icon(v-html="$icons['text/center']")

      .action(
        @click="textRight" :class="{ active: right }"
        v-tooltip:top="'Right'"
      )
        .icon(v-html="$icons['text/right']")

      .action(
        v-tooltip:top="'Smaller'"
        @click="textSmaller"
      )
        .icon(v-html="$icons['text/smaller']")

      .action.last(
        v-tooltip:top="'Bigger'"
        @click="textBigger"
      )
        .icon(v-html="$icons['text/bigger']")
</template>

<script>
import { mapState } from 'vuex'
import storeService from '../services/store'
import TextBoldCommand from '../history/commands/text/bold'
import TextNormalCommand from '../history/commands/text/normal'
import TextItalicCommand from '../history/commands/text/italic'
import TextLeftCommand from '../history/commands/text/left'
import TextRightCommand from '../history/commands/text/right'
import TextCenterCommand from '../history/commands/text/center'
import TextBiggerCommand from '../history/commands/text/bigger'
import TextSmallerCommand from '../history/commands/text/smaller'

export default {
  name: 'TextTools',
  props: {
    isSmall: {
      default: false,
      type: Boolean
    }
  },
  data () {
    return {
      styles: {},
      isShown: false,
      bold: false,
      italic: false,
      left: false,
      right: false,
      center: false,
      colorPickerStyle: {}
    }
  },
  computed: {
    ...mapState({
      activeItem: state => state.editor.activeItem,
      loadedFonts: state => state.editor.loadedFonts
    })
  },
  methods: {
    show () {
      const activeItem = storeService.get('activeItem')
      this.bold = activeItem.fontStyle() === 'bold'
      this.italic = activeItem.fontStyle() === 'italic'
      this.right = activeItem.align() === 'right'
      this.left = activeItem.align() === 'left'
      this.center = activeItem.align() === 'center'
      this.fontFamily = activeItem.fontFamily()
      this.isShown = true
      this.calculatePosition()
    },
    hide () {
      this.isShown = false
    },
    calculatePosition () {
      const activeItem = storeService.get('activeItem')
      if (activeItem) {
        const activeItemHeight = activeItem.height() * activeItem.scaleY()
        let top = activeItem.y() - activeItem.height() / 2 - 55
        let left = Math.floor(activeItem.x() - activeItem.width() / 2)

        // If toolbar is outside the upper rim - recalculate Y position
        if (top < 0) {
          top = activeItem.y() + activeItemHeight / 2 + 11
        }

        this.styles = {
          top: top + 'px',
          left: left + 'px'
        }
      }
    },
    textBigger () {
      storeService.get('commandManager').execute(new TextBiggerCommand(storeService.get('activeItem')))
    },
    textSmaller () {
      storeService.get('commandManager').execute(new TextSmallerCommand(storeService.get('activeItem')))
    },
    textLeft () {
      storeService.get('commandManager').execute(new TextLeftCommand(storeService.get('activeItem')))
      this.left = true
      this.center = false
      this.right = false
    },
    textCenter () {
      storeService.get('commandManager').execute(new TextCenterCommand(storeService.get('activeItem')))
      this.center = true
      this.left = false
      this.right = false
    },
    textRight () {
      storeService.get('commandManager').execute(new TextRightCommand(storeService.get('activeItem')))
      this.right = true
      this.center = false
      this.left = false
    },
    textBold () {
      const textNode = storeService.get('activeItem')
      if (textNode.fontStyle() === 'bold') {
        storeService.get('commandManager').execute(new TextNormalCommand(textNode, 'bold'))
        this.bold = false
      } else {
        storeService.get('commandManager').execute(new TextBoldCommand(textNode))
        this.bold = true
        this.italic = false
      }
    },
    textItalic () {
      const textNode = storeService.get('activeItem')
      if (textNode.fontStyle() === 'italic') {
        storeService.get('commandManager').execute(new TextNormalCommand(textNode, 'italic'))
        this.italic = false
      } else {
        storeService.get('commandManager').execute(new TextItalicCommand(textNode))
        this.italic = true
        this.bold = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../assets/css/mixins';
@import '../assets/css/variables';

.text-tools {
  height: 43px;
  position: absolute;
  top: -11px;
  z-index: 40;

  .actions {
    height: 100%;
    position: relative;
    z-index: 20;
    display: flex;
    flex-direction: row;
    align-items: center;

    .action {
      display: flex;
      flex-direction: row;
      align-items: center;
      justify-content: center;
      background-color: $toolbar-background-color;
      padding: 0 16px;
      height: 100%;
      cursor: pointer;

      &.first {
        border-radius: 100px 0 0 100px;
        overflow: hidden;
      }

      &.last {
        border-radius: 0 100px 100px 0;
        overflow: hidden;
      }

      &.color-picker {
        padding: 0 11px;

        img {
          width: 20px;
        }
      }

      .icon {
        height: 15px;
        width: 15px;
        fill: #fff;

        img {
          width: 100%;
        }
      }

      &:hover {
        background-color: $toolbar-background-color-hover;
        @include delay()
      }

      &.active {
        background-color: #fff;

        .icon {
          fill: #000;
        }
      }
    }
  }

  &.small {
    height: 36px;

    .action {
      padding: 0 10px;
    }
  }
}
</style>
